import { select,
        scaleOrdinal,
        schemeSpectral} from 'd3';
import  { loadAndProcessData } from './loadAndProcessData';
import { colorLegend } from './colorLegend'
import  { choroplethMap } from './choroplethMap';


const svg = select('svg');

const g = svg.append('g');

const colorScale = scaleOrdinal();
const colorValue = d => d.properties.economy;

const choroplethMapG = svg.append('g');

const colorLegendG = svg.append('g')
  .attr('transform',`translate(50,330)`);

let selectedColorValue;
let features;

const onClick = d=>{
  selectedColorValue = d===selectedColorValue
    ? null
    : d
  render()
	}

const render = () => {
  colorScale
    .domain(features.map(colorValue))
    .domain(colorScale.domain().sort())
    .range(schemeSpectral[colorScale.domain().length])
    .range(colorScale.range().reverse())
  
  
  colorLegendG.call(colorLegend, {
    colorScale,
    circleRadius:8,
    spacing: 20,
    textOffset: 15,
    backgroundRectWidth:250,
    onClick: onClick,
    selectedColorValue: selectedColorValue
  })
  
  choroplethMapG.call(choroplethMap, {
    features,
    colorScale,
    colorValue,
    selectedColorValue
  });
}

loadAndProcessData().then(countries => {
  features = countries.features;
  render();
  
})
