import {json, 
        tsv} from 'd3';

import {feature} from 'topojson';

export const loadAndProcessData = () =>
  Promise
  .all([tsv('https://unpkg.com/world-atlas@1.1.4/world/50m.tsv'),
        json('https://unpkg.com/world-atlas@1.1.4/world/50m.json')])
  .then(([tsvData, jsonData])=>{
    const countries = feature(jsonData, jsonData.objects.countries);
    // const countryName = {};
    // tsvData.forEach(d=>countryName[d.iso_n3]=d.name)

    const rowById = tsvData.reduce((accumulator, d) => {
      accumulator[d.iso_n3]=d;
      return(accumulator);
      },{})

    countries.features.forEach(d=>{
     Object.assign(d.properties,rowById[d.id])})
      
    return countries
    });
